HTTP/1.1 -1 Read error in cache disk data: SuccessContent-Type: text/plain
Last-Modified: Sat, 17 Jan 2009 06:03:55 GMT
ETag: "43c0e-3ced-460a7745e88c0"
Content-length: 15597
Connection: Close
Proxy-Connection: Close
X-Cache: HIT from web1.osuosl.org
Server: ProxyTrack 0.5 (HTTrack 3.49.2)

Index: languages/perl6/src/pmc/perl6str.pmc
===================================================================
--- languages/perl6/src/pmc/perl6str.pmc	£¨°æ±¾ 35658£©
+++ languages/perl6/src/pmc/perl6str.pmc	£¨¹¤×÷¸±±¾£©
@@ -261,6 +261,8 @@
 either side of the letters or digits that return true for C<isalpha()> or
 C<isdigit()> respectively.
 
+=cut
+
 */
 
     VTABLE void increment() {
Index: src/dynext.c
===================================================================
--- src/dynext.c	£¨°æ±¾ 35658£©
+++ src/dynext.c	£¨¹¤×÷¸±±¾£©
@@ -378,7 +378,6 @@
     STRING *type;
     PMC *(*load_func)(PARROT_INTERP);
     void (*init_func)(PARROT_INTERP, PMC *);
-    char *cinit_func_name;
     PMC *lib_pmc;
 
     /*
@@ -387,22 +386,20 @@
      */
     Parrot_block_GC_mark(interp);
 
-    /* get load_func */
     if (lib_name) {
-        STRING * const load_name  = Parrot_sprintf_c(interp,
+        STRING * const load_name       = Parrot_sprintf_c(interp,
                                         "Parrot_lib_%Ss_load", lib_name);
+        STRING * const init_func_name  = Parrot_sprintf_c(interp,
+                                        "Parrot_lib_%Ss_init", lib_name);
         char   * const cload_func_name = string_to_cstring(interp, load_name);
-        STRING *init_func_name;
+        char   * const cinit_func_name = string_to_cstring(interp, init_func_name);
 
-        load_func    = (PMC * (*)(PARROT_INTERP))
+        /* get load_func */
+        load_func       = (PMC * (*)(PARROT_INTERP))
             D2FPTR(Parrot_dlsym(handle, cload_func_name));
-
         string_cstring_free(cload_func_name);
 
         /* get init_func */
-        init_func_name  = Parrot_sprintf_c(interp, "Parrot_lib_%Ss_init",
-                                          lib_name);
-        cinit_func_name = string_to_cstring(interp, init_func_name);
         init_func       = (void (*)(PARROT_INTERP, PMC *))
             D2FPTR(Parrot_dlsym(handle, cinit_func_name));
         string_cstring_free(cinit_func_name);
@@ -454,9 +451,9 @@
 clone_string_into(ARGMOD(Interp *d), ARGIN(Interp *s), ARGIN(PMC *value))
 {
     ASSERT_ARGS(clone_string_into)
-    STRING * const orig = VTABLE_get_string(s, value);
+    STRING * const  orig = VTABLE_get_string(s, value);
     char * const raw_str = string_to_cstring(s, orig);
-    STRING * const ret =
+    STRING * const   ret =
         string_make_direct(d, raw_str, strlen(raw_str),
             PARROT_DEFAULT_ENCODING, PARROT_DEFAULT_CHARSET,
             PObj_constant_FLAG);
Index: src/dynpmc/gdbmhash.pmc
===================================================================
--- src/dynpmc/gdbmhash.pmc	£¨°æ±¾ 35658£©
+++ src/dynpmc/gdbmhash.pmc	£¨¹¤×÷¸±±¾£©
@@ -116,8 +116,9 @@
 */
 
     void set_string_native(STRING* value) {
-        char *c_db_name      = string_to_cstring(interp, value);
-        GDBM_FILE dbf        = gdbm_open(c_db_name, 0, GDBM_NEWDB, 0666, 0);
+        char * const c_db_name = string_to_cstring(interp, value);
+        GDBM_FILE dbf          = 
+	    gdbm_open(c_db_name, 0, GDBM_NEWDB, 0666, 0);
 
         string_cstring_free(c_db_name);
 
Index: src/dynpmc/rational.pmc
===================================================================
--- src/dynpmc/rational.pmc	£¨°æ±¾ 35658£©
+++ src/dynpmc/rational.pmc	£¨¹¤×÷¸±±¾£©
@@ -54,9 +54,8 @@
 */
 static STRING *rat_get_string_to_base(PARROT_INTERP, PMC *self, int base) {
   #ifdef PARROT_HAS_GMP
-    STRING *pstr;
-    char *cstr = mpq_get_str(NULL, (int) base, RT(self));
-    pstr = string_from_cstring(interp, cstr, 0);
+    char * const cstr = mpq_get_str(NULL, (int) base, RT(self));
+    STRING * pstr     = string_from_cstring(interp, cstr, 0);
     string_cstring_free(cstr);
     return pstr;
   #else
@@ -391,7 +390,7 @@
 */
     VTABLE void set_string_native(STRING *value) {
       #ifdef PARROT_HAS_GMP
-        char *cstr = string_to_cstring(INTERP, value);
+        char * const cstr = string_to_cstring(INTERP, value);
         mpq_set_str(RT(SELF), cstr, 0);
         mpq_canonicalize(RT(SELF));
         string_cstring_free(cstr);
@@ -409,7 +408,7 @@
 */
     VTABLE void set_string_keyed_int(INTVAL base, STRING *value) {
       #ifdef PARROT_HAS_GMP
-        char *cstr = string_to_cstring(INTERP, value);
+        char * const cstr = string_to_cstring(INTERP, value);
         mpq_set_str(RT(SELF), cstr, (int) base);
         mpq_canonicalize(RT(SELF));
         string_cstring_free(cstr);
Index: src/hll.c
===================================================================
--- src/hll.c	£¨°æ±¾ 35658£©
+++ src/hll.c	£¨¹¤×÷¸±±¾£©
@@ -95,9 +95,9 @@
     PMC * const entry = constant_pmc_new(interp, enum_class_FixedPMCArray);
 
     if (entry_name && !STRING_IS_EMPTY(entry_name)) {
-        char   *cstring    = string_to_cstring(interp, entry_name);
-        UINTVAL len        = string_length(interp, entry_name);
-        STRING *const_name = string_make_direct(interp, cstring,
+        char   * const cstring    = string_to_cstring(interp, entry_name);
+        const  UINTVAL len        = string_length(interp, entry_name);
+        STRING *const_name        = string_make_direct(interp, cstring,
             len, PARROT_DEFAULT_ENCODING, PARROT_DEFAULT_CHARSET,
             PObj_constant_FLAG);
 
Index: src/inter_call.c
===================================================================
--- src/inter_call.c	£¨°æ±¾ 35658£©
+++ src/inter_call.c	£¨¹¤×÷¸±±¾£©
@@ -2795,7 +2795,7 @@
 
     /* create the signature string, and the various PMCs that are needed to
        store all the parameters and parameter counts. */
-    char *signature         = string_to_cstring(interp, VTABLE_get_string(interp, sig_obj));
+    char * const signature  = string_to_cstring(interp, VTABLE_get_string(interp, sig_obj));
     PMC * const args_sig    = temporary_pmc_new(interp, enum_class_FixedIntegerArray);
     PMC * const results_sig = temporary_pmc_new(interp, enum_class_FixedIntegerArray);
     PMC * const ret_cont    = new_ret_continuation_pmc(interp, NULL);
Index: src/io/portable.c
===================================================================
--- src/io/portable.c	£¨°æ±¾ 35658£©
+++ src/io/portable.c	£¨¹¤×÷¸±±¾£©
@@ -144,7 +144,7 @@
     flags |= PIO_F_FILE;
 
     { /* scope for temporary C string */
-        const char *spath = string_to_cstring(interp, path);
+        char * const spath = string_to_cstring(interp, path);
         /* Try opening the file
          * note that this can't really handle O_EXCL, etc. */
         fptr = fopen(spath, oflags);
Index: src/io/win32.c
===================================================================
--- src/io/win32.c	£¨°æ±¾ 35658£©
+++ src/io/win32.c	£¨¹¤×÷¸±±¾£©
@@ -224,7 +224,7 @@
     flags |= PIO_F_FILE;
 
     { /* enclosing scope for temporary C string */
-        char *spath = string_to_cstring(interp, path);
+        char * const spath = string_to_cstring(interp, path);
         fd = CreateFile(spath, fAcc, fShare, NULL, fCreat,
                     FILE_ATTRIBUTE_NORMAL, NULL);
         string_cstring_free(spath);
Index: src/jit_debug.c
===================================================================
--- src/jit_debug.c	£¨°æ±¾ 35658£©
+++ src/jit_debug.c	£¨¹¤×÷¸±±¾£©
@@ -283,7 +283,7 @@
 
     if (interp->code->debugs) {
         char *ext;
-        char *src = string_to_cstring(interp,
+        char * const src = string_to_cstring(interp,
             Parrot_debug_pc_to_filename(interp,
             interp->code->debugs, 0));
         pasmfile = string_make(interp, src, strlen(src), NULL,
@@ -364,8 +364,8 @@
     cmd = Parrot_sprintf_c(interp, "as %Ss -o %Ss", stabsfile, ofile);
 
     {
-        char *temp   = string_to_cstring(interp, cmd);
-        int   status = system(temp);
+        char * const temp   = string_to_cstring(interp, cmd);
+        int          status = system(temp);
         if (status)
             fprintf(stderr, "Assembly failed: %d\n%s\n", status, temp);
         string_cstring_free(temp);
Index: src/jit_debug_xcoff.c
===================================================================
--- src/jit_debug_xcoff.c	£¨°æ±¾ 35658£©
+++ src/jit_debug_xcoff.c	£¨¹¤×÷¸±±¾£©
@@ -254,7 +254,7 @@
 
     if (interp->code->debugs) {
         char *ext;
-        char *src = string_to_cstring(interp,
+        char * const src = string_to_cstring(interp,
             Parrot_debug_pc_to_filename(interp,
             interp->code->debugs, 0));
         pasmfile = string_make(interp, src, strlen(src), NULL,
@@ -280,7 +280,7 @@
     stabsfile = debug_file(interp, file, "stabs.s");
     ofile = debug_file(interp, file, "o");
     {
-        char *temp = string_to_cstring(interp, stabsfile);
+        char * const temp = string_to_cstring(interp, stabsfile);
         stabs      = fopen(temp, "w");
         string_cstring_free(temp);
     }
@@ -288,7 +288,7 @@
         return;
 
     {
-        char *temp = string_to_cstring(interp, pasmfile);
+        char * const temp = string_to_cstring(interp, pasmfile);
         /* filename info */
         fprintf(stabs, ".file \"%s\"\n", temp);
         string_cstring_free(temp);
@@ -334,7 +334,7 @@
     cmd = Parrot_sprintf_c(interp, "as %Ss -o %Ss", stabsfile, ofile);
 
     {
-        char *temp = string_to_cstring(interp, cmd);
+        char * const temp = string_to_cstring(interp, cmd);
         system(temp);
         string_cstring_free(temp);
     }
Index: src/packfile.c
===================================================================
--- src/packfile.c	£¨°æ±¾ 35658£©
+++ src/packfile.c	£¨¹¤×÷¸±±¾£©
@@ -2590,7 +2590,7 @@
 
     Parrot_io_printf(interp, "\n  mappings => [\n");
     for (i = 0; i < debug->num_mappings; i++) {
-        char *filename = string_to_cstring(interp, PF_CONST(debug->code,
+        char * const filename = string_to_cstring(interp, PF_CONST(debug->code,
                    debug->mappings[i]->filename)->u.string);;
         Parrot_io_printf(interp, "    #%d\n    [\n", i);
         Parrot_io_printf(interp, "        OFFSET => %d,\n",
@@ -4058,7 +4058,7 @@
     /* Dump keys. */
     Parrot_io_printf(interp, "\n  keys => [\n");
     for (i = 0; i < self->num_keys; i++) {
-        char *key_name = string_to_cstring(interp, PF_CONST(self->code,
+        char * const key_name = string_to_cstring(interp, PF_CONST(self->code,
                self->keys[i]->name)->u.string);
         Parrot_io_printf(interp, "    #%d\n    [\n", i);
         Parrot_io_printf(interp, "        NAME => %s\n", key_name);
Index: src/pmc/bigint.pmc
===================================================================
--- src/pmc/bigint.pmc	£¨°æ±¾ 35658£©
+++ src/pmc/bigint.pmc	£¨¹¤×÷¸±±¾£©
@@ -587,13 +587,13 @@
 */
 
     VTABLE void set_string_native(STRING *value) {
-        char *s = string_to_cstring(INTERP, value);
+        char * const s = string_to_cstring(INTERP, value);
         bigint_set_str(INTERP, SELF, s, 10);
         string_cstring_free(s);
     }
 
     VTABLE void set_string_keyed_int(INTVAL base, STRING *value) {
-        char *s = string_to_cstring(INTERP, value);
+        char * const s = string_to_cstring(INTERP, value);
         bigint_set_str(INTERP, SELF, s, base);
         string_cstring_free(s);
     }
Index: src/pmc/file.pmc
===================================================================
--- src/pmc/file.pmc	£¨°æ±¾ 35658£©
+++ src/pmc/file.pmc	£¨¹¤×÷¸±±¾£©
@@ -65,7 +65,7 @@
 
     METHOD exists(STRING *path) {
         struct stat info;
-        char *cpath = string_to_cstring(interp, path);
+        char * const cpath = string_to_cstring(interp, path);
 #ifdef WIN32
         int error   = stat(cpath, &info);
 #else
@@ -91,7 +91,7 @@
 
     METHOD is_dir(STRING *path) {
         struct stat info;
-        char *cpath = string_to_cstring(interp, path);
+        char * const cpath = string_to_cstring(interp, path);
 #ifdef WIN32
         int error   = stat(cpath, &info);
 #else
@@ -123,7 +123,7 @@
 
     METHOD is_file(STRING *path) {
         struct stat info;
-        char *cpath = string_to_cstring(interp, path);
+        char * const cpath = string_to_cstring(interp, path);
 #ifdef WIN32
         int error   = stat(cpath, &info);
 #else
@@ -160,8 +160,8 @@
 #else
         struct stat info;
 
-        char *cpath = string_to_cstring(interp, path);
-        int error   = lstat(cpath, &info);
+        char * const cpath = string_to_cstring(interp, path);
+        int          error = lstat(cpath, &info);
 
         string_cstring_free(cpath);
 
@@ -197,14 +197,14 @@
     METHOD copy(STRING *from, STRING *to) {
 #define CHUNK_SIZE 1024
 
-        char *cfrom  = string_to_cstring(interp, from);
-        FILE *source = fopen(cfrom, "rb");
+        char * const cfrom  = string_to_cstring(interp, from);
+        FILE       * source = fopen(cfrom, "rb");
 
         string_cstring_free(cfrom);
 
         if (source) {
-            char *cto    = string_to_cstring(interp, to);
-            FILE *target = fopen(cto, "w+b");
+            char * const cto = string_to_cstring(interp, to);
+            FILE    * target = fopen(cto, "w+b");
 
             string_cstring_free(cto);
 
@@ -251,9 +251,9 @@
 */
 
     METHOD rename(STRING *from, STRING *to) {
-        char *cfrom = string_to_cstring(interp, from);
-        char *cto   = string_to_cstring(interp, to);
-        int error   = rename(cfrom, cto);
+        char * const cfrom = string_to_cstring(interp, from);
+        char * const   cto = string_to_cstring(interp, to);
+        int          error = rename(cfrom, cto);
 
         string_cstring_free(cfrom);
         string_cstring_free(cto);
Index: src/pmc/nci.pmc
===================================================================
--- src/pmc/nci.pmc	£¨°æ±¾ 35658£©
+++ src/pmc/nci.pmc	£¨¹¤×÷¸±±¾£©
@@ -167,12 +167,12 @@
 
     VTABLE void set_pointer_keyed_str(STRING *key, void *func) {
         Parrot_NCI_attributes * const nci_info = PARROT_NCI(SELF);
-        int                           jitted   = 0;
-        char                         *key_c;
+        int                             jitted = 0;
+        char                     * const key_c = 
+	    string_to_cstring(INTERP, key);
 
         /* Store the original function and signature. */
         PMC_struct_val(SELF) = func;
-        key_c                = string_to_cstring(INTERP, key);
         nci_info->signature  = string_make(interp, key_c, strlen(key_c),
                                     NULL, PObj_constant_FLAG);
         string_cstring_free(key_c);
Index: src/pmc/os.pmc
===================================================================
--- src/pmc/os.pmc	£¨°æ±¾ 35658£©
+++ src/pmc/os.pmc	£¨¹¤×÷¸±±¾£©
@@ -137,8 +137,8 @@
 
     METHOD rm(STRING *path) {
         struct stat info;
-        char *cpath = string_to_cstring(interp, path);
-        int   error = stat(cpath, &info);
+        char * const cpath = string_to_cstring(interp, path);
+        int          error = stat(cpath, &info);
 
         if (error) {
             const char * const errmsg = strerror(errno);
Index: src/pmc/sub.pmc
===================================================================
--- src/pmc/sub.pmc	£¨°æ±¾ 35658£©
+++ src/pmc/sub.pmc	£¨¹¤×÷¸±±¾£©
@@ -832,7 +832,7 @@
 
     METHOD __get_regs_used(STRING *reg) {
         Parrot_sub * const sub  = PMC_sub(SELF);
-        char              *kind = string_to_cstring(interp, reg);
+        char       * const kind = string_to_cstring(interp, reg);
         INTVAL             regs_used;
 
         /* TODO switch to canonical NiSP order
/><link rel="stylesheet" href="/parrot/themeengine/theme.css" type="text/css" />
        <link