HTTP/1.1 -1 Read error in cache disk data: SuccessContent-Type: text/plain
Last-Modified: Sat, 07 Feb 2009 14:13:34 GMT
ETag: "43c3e-5df5-46254be295f80"
Content-length: 24053
Connection: Close
Proxy-Connection: Close
X-Cache: HIT from web1.osuosl.org
Server: ProxyTrack 0.5 (HTTrack 3.49.2)

Index: config/gen/makefiles/root.in
===================================================================
--- config/gen/makefiles/root.in	(revision 36416)
+++ config/gen/makefiles/root.in	(working copy)
@@ -458,7 +458,7 @@
 PARROT              = $(CUR_DIR)/@test_prog@$(EXE)
 MINIPARROT          = $(CUR_DIR)/miniparrot$(EXE)
 DIS                 = $(CUR_DIR)/pbc_disassemble$(EXE)
-PDUMP               = $(CUR_DIR)/pdump$(EXE)
+PDUMP               = $(CUR_DIR)/pbc_dump$(EXE)
 PINFO               = $(CUR_DIR)/pbc_info$(EXE)
 PBCMERGE            = $(CUR_DIR)/pbc_merge$(EXE)
 PDB                 = $(CUR_DIR)/parrot_debugger$(EXE)
@@ -468,7 +468,7 @@
 # Installable executables
 INSTALLABLEPARROT   = $(CUR_DIR)/installable_parrot$(EXE)
 INSTALLABLEDIS      = $(CUR_DIR)/installable_pbc_disassemble$(EXE)
-INSTALLABLEPDUMP    = $(CUR_DIR)/installable_pdump$(EXE)
+INSTALLABLEPDUMP    = $(CUR_DIR)/installable_pbc_dump$(EXE)
 INSTALLABLEPINFO    = $(CUR_DIR)/installable_pbc_info$(EXE)
 INSTALLABLEPBCMERGE = $(CUR_DIR)/installable_pbc_merge$(EXE)
 INSTALLABLEPDB      = $(CUR_DIR)/installable_parrot_debugger$(EXE)
@@ -903,17 +903,17 @@
 # Parrot Dump
 #

-$(PDUMP) : $(SRC_DIR)/pdump$(O) $(SRC_DIR)/packdump$(O) $(LIBPARROT)
+$(PDUMP) : $(SRC_DIR)/pbc_dump$(O) $(SRC_DIR)/packdump$(O) $(LIBPARROT)
 	$(LINK) @ld_out@$@ \
-    $(SRC_DIR)/pdump$(O) \
+    $(SRC_DIR)/pbc_dump$(O) \
     $(SRC_DIR)/packdump$(O) @rpath_blib@ $(ALL_PARROT_LIBS) $(LINKFLAGS)
 #IF(win32):	if exist $@.manifest mt.exe -nologo -manifest $@.manifest -outputresource:$@;1

-$(SRC_DIR)/pdump$(O) : $(GEN_HEADERS)
+$(SRC_DIR)/pbc_dump$(O) : $(GEN_HEADERS)

-$(INSTALLABLEPDUMP) : $(SRC_DIR)/pdump$(O) $(SRC_DIR)/packdump$(O) $(LIBPARROT)
+$(INSTALLABLEPDUMP) : $(SRC_DIR)/pbc_dump$(O) $(SRC_DIR)/packdump$(O) $(LIBPARROT)
 	$(LINK) @ld_out@$@ \
-    $(SRC_DIR)/pdump$(O) \
+    $(SRC_DIR)/pbc_dump$(O) \
     $(SRC_DIR)/packdump$(O) \
     @rpath_lib@ $(ALL_PARROT_LIBS) $(LINKFLAGS)
 #IF(win32):	if exist $@.manifest mt.exe -nologo -manifest $@.manifest -outputresource:$@;1
@@ -1597,7 +1597,7 @@
     $(INSTALLABLEPDB) \
     pbc_to_exe.pir pbc_to_exe.pbc pbc_to_exe.c pbc_to_exe$(O) pbc_to_exe$(EXE) \
     $(IMCC_DIR)/main$(O) \
-    $(PDUMP) $(SRC_DIR)/pdump$(O) $(SRC_DIR)/packdump$(O) \
+    $(PDUMP) $(SRC_DIR)/pbc_dump$(O) $(SRC_DIR)/packdump$(O) \
     $(SRC_DIR)/pbc_info$(O) $(PINFO) \
     $(PDB) $(SRC_DIR)/parrot_debugger$(O) \
     $(PBCMERGE) $(SRC_DIR)/pbc_merge$(O) \
@@ -1634,7 +1634,7 @@
     $(INSTALLABLEPDB) \
     $(INSTALLABLECONFIG) \
     $(IMCC_DIR)/main$(O) \
-    $(PDUMP) $(SRC_DIR)/pdump$(O) $(SRC_DIR)/packdump$(O) \
+    $(PDUMP) $(SRC_DIR)/pbc_dump$(O) $(SRC_DIR)/packdump$(O) \
     $(SRC_DIR)/pbc_info$(O) $(PINFO) \
     $(PDB) $(SRC_DIR)/parrot_debugger$(O) \
     $(PBCMERGE) $(SRC_DIR)/pbc_merge$(O) \
Index: docs/dev/fhs.pod
===================================================================
--- docs/dev/fhs.pod	(revision 36416)
+++ docs/dev/fhs.pod	(working copy)
@@ -56,7 +56,7 @@

 This is the primary directory of executable commands on the system. All
 executables that are intended to be called directly by the user (i.e.
-parrot, pdump, disassemble, parrot-debugger, pbc_info,  pbg_merge, ...)
+parrot, parrot_debugger, pbc_disassemble, pbc_dump, pbc_info, pbg_merge, ...)
 should go here. The current version number should be appended to the
 binaries itself and a symlink needs to be created that points from the
 binary with version number to the normal name of the file without a
Index: docs/parrotbyte.pod
===================================================================
--- docs/parrotbyte.pod	(revision 36416)
+++ docs/parrotbyte.pod	(working copy)
@@ -25,8 +25,8 @@

 The B<Wordsize> (or C<opcode_t> size) must be 4 (32-bit) or 8 (64 bit). The
 bytecode loader is responsible for transforming the file into the VM native
-wordsize on the fly. For performance, a utility F<pdump> is provided to convert
-PBCs on disk if they cannot be recompiled. See F<src/pdump.c> for more
+wordsize on the fly. For performance, a utility F<pbc_dump> is provided to convert
+PBCs on disk if they cannot be recompiled. See F<src/pbc_dump.c> for more
 information.

 B<Byteorder> currently supports two values: (0-Little Endian, 1-Big Endian)
@@ -333,7 +333,7 @@
 =head1 SEE ALSO

 F<packfile.c>, F<packfile.h>, F<packout.c>, F<packdump.c>, F<pf/*.c>, and the
-B<pdump> utility F<pdump.c>.
+B<pbc_dump> utility F<pbc_dump.c>.

 =head1 AUTHOR

Index: MANIFEST
===================================================================
--- MANIFEST	(revision 36416)
+++ MANIFEST	(working copy)
@@ -1,7 +1,7 @@
 # ex: set ro:
 # $Id$
 #
-# generated by tools/dev/mk_manifest_and_skip.pl Sun Feb  1 22:48:40 2009 UT
+# generated by tools/dev/mk_manifest_and_skip.pl Sat Feb  7 12:51:06 2009 UT
 #
 # See tools/dev/install_files.pl for documentation on the
 # format of this file.
@@ -2796,9 +2797,9 @@
 src/packout.c                                               []
 src/parrot_debugger.c                                       []
 src/pbc_disassemble.c                                       []
+src/pbc_dump.c                                              []
 src/pbc_info.c                                              []
 src/pbc_merge.c                                             []
-src/pdump.c                                                 []
 src/pic.c                                                   []
 src/pic_jit.c                                               []
 src/pmc.c                                                   []
Index: MANIFEST.generated
===================================================================
--- MANIFEST.generated	(revision 36416)
+++ MANIFEST.generated	(working copy)
@@ -66,16 +66,18 @@
 installable_parrot_debugger.exe                   [main]bin
 installable_pbc_disassemble                       [main]bin
 installable_pbc_disassemble.exe                   [main]bin
+installable_pbc_dump                              [main]bin
+installable_pbc_dump.exe                          [main]bin
 installable_pbc_info                              [main]bin
 installable_pbc_info.exe                          [main]bin
 installable_pbc_merge                             [main]bin
 installable_pbc_merge.exe                         [main]bin
-installable_pdump                                 [main]bin
-installable_pdump.exe                             [main]bin
 libparrot.dll                                     [main]bin
 parrot.pc                                         [main]pkgconfig
 pbc_disassemble                                   [main]bin
 pbc_disassemble.exe                               [main]bin
+pbc_dump                                          [main]bin
+pbc_dump.exe                                      [main]bin
 pbc_info                                          [main]bin
 pbc_info.exe                                      [main]bin
 pbc_merge                                         [main]bin
@@ -84,8 +86,6 @@
 pbc_to_exe.exe                                    [main]bin
 pdb                                               [main]bin
 pdb.exe                                           [main]bin
-pdump                                             [main]bin
-pdump.exe                                         [main]bin
 runtime/parrot/dynext/apl_group.bundle            [library]
 runtime/parrot/dynext/apl_group.dll               [library]
 runtime/parrot/dynext/apl_group.dylib             [library]
Index: parrot.spec
===================================================================
--- parrot.spec	(revision 36416)
+++ parrot.spec	(working copy)
@@ -115,7 +115,6 @@
 %exclude %{_bindir}/perl6
 %exclude %{_bindir}/parrot_debugger
 %exclude %{_bindir}/pbc_*
-%exclude %{_bindir}/pdump
 %{_bindir}/*
 %{_libdir}/parrot
 %{_libdir}/libparrot.so.*
@@ -135,7 +134,7 @@
 %{_bindir}/pbc_info
 %{_bindir}/pbc_merge
 %{_bindir}/pbc_to_exe
-%{_bindir}/pdump
+%{_bindir}/pbc_dump
 %{_includedir}/parrot
 %{_libdir}/libparrot.so
 %{_libdir}/libparrot.a
Index: ports/cygwin/README
===================================================================
--- ports/cygwin/README	(revision 36416)
+++ ports/cygwin/README	(working copy)
@@ -57,10 +57,10 @@
   /usr/bin/parrot.exe
   /usr/bin/parrot_config.exe
   /usr/bin/parrot_debugger.exe
+  /usr/bin/pbc_dump.exe
   /usr/bin/pbc_info.exe
   /usr/bin/pbc_merge.exe
   /usr/bin/pbc_to_exe.exe
-  /usr/bin/pdump.exe
   /usr/lib/parrot/config_lib.pasm
   /usr/lib/parrot/myconfig
   /usr/lib/parrot/parrotbug
Index: ports/debian/parrot.install
===================================================================
--- ports/debian/parrot.install	(revision 36416)
+++ ports/debian/parrot.install	(working copy)
@@ -1,6 +1,6 @@
 usr/bin/parrot
 usr/bin/pbc_disassemble
+usr/bin/pbc_dump
 usr/bin/pbc_info
 usr/bin/pbc_merge
-usr/bin/pdump
 usr/lib/parrot/*
Index: ports/debian/rules
===================================================================
--- ports/debian/rules	(revision 36416)
+++ ports/debian/rules	(working copy)
@@ -21,12 +21,12 @@

 build: build-stamp

-build-stamp: configure-stamp
+build-stamp: configure-stamp
 	dh_testdir
 	$(MAKE) installable
 	pod2man --section=1 --release="Debian Project" --center="Debian GNU/Linux manual" docs/running.pod debian/parrot.1
 	pod2man --section=1 --release="Debian Project" --center="Debian GNU/Linux manual" parrot_config debian/parrot_config.1
-	pod2man --section=1 --release="Debian Project" --center="Debian GNU/Linux manual" src/pdump.c debian/pdump.1
+	pod2man --section=1 --release="Debian Project" --center="Debian GNU/Linux manual" src/pbc_dump.c debian/pbc_dump.1
 	pod2man --section=1 --release="Debian Project" --center="Debian GNU/Linux manual" src/pbc_disassemble.c debian/pbc_disassemble.1
 	pod2man --section=1 --release="Debian Project" --center="Debian GNU/Linux manual" src/parrot_debugger.c debian/parrot-debugger.1
 	pod2man --section=1 --release="Debian Project" --center="Debian GNU/Linux manual" src/pbc_info.c debian/pbc_info.1
@@ -36,9 +36,9 @@
 clean:
 	dh_testdir
 	dh_testroot
-	rm -f build-stamp configure-stamp debian/parrot.1 debian/parrot_config.1 debian/pdump.1 debian/pbc_disassemble.1 debian/parrot-debugger.1 debian/pbc_info.1 debian/pbc_merge.1 debian/libparrot$(SOVERSION).install src/nci_test.o src/main.o ext/Parrot-Embed/Makefile.PL languages/PIR/Makefile languages/perl5/Makefile languages/pynie/Makefile runtime/parrot/include/signal.pasm test.c test.ldo
+	rm -f build-stamp configure-stamp debian/parrot.1 debian/parrot_config.1 debian/pbc_dump.1 debian/pbc_disassemble.1 debian/parrot-debugger.1 debian/pbc_info.1 debian/pbc_merge.1 debian/libparrot$(SOVERSION).install src/nci_test.o src/main.o ext/Parrot-Embed/Makefile.PL languages/PIR/Makefile languages/perl5/Makefile languages/pynie/Makefile runtime/parrot/include/signal.pasm test.c test.ldo
 	[ ! -f Makefile ] || $(MAKE) distclean
-	dh_clean
+	dh_clean

 debian/libparrot$(SOVERSION).install: debian/libparrot.install VERSION
 	cp $< $@
@@ -77,7 +77,7 @@
 	dh_testdir -a
 	dh_testroot -a
 	dh_installchangelogs -a ChangeLog
-	dh_installman -pparrot debian/parrot.1 debian/pdump.1 debian/pbc_disassemble.1 debian/parrot-debugger.1 debian/pbc_info.1 debian/pbc_merge.1
+	dh_installman -pparrot debian/parrot.1 debian/pbc_dump.1 debian/pbc_disassemble.1 debian/parrot-debugger.1 debian/pbc_info.1 debian/pbc_merge.1
 	dh_installdocs -a
 	dh_strip -a
 	dh_compress -a
Index: src/packdump.c
===================================================================
--- src/packdump.c	(revision 36416)
+++ src/packdump.c	(working copy)
@@ -10,7 +10,7 @@

 =head1 DESCRIPTION

-This is only used by the PBC dumper C<pdump>.
+This is only used by the PBC dumper C<pbc_dump>.

 =head2 Functions

@@ -397,7 +397,7 @@

 =head1 SEE ALSO

-F<src/pdump.c>.
+F<src/pbc_dump.c>.

 =cut

Index: src/pbc_dump.c
===================================================================
--- src/pbc_dump.c	(revision 36414)
+++ src/pbc_dump.c	(working copy)
@@ -4,13 +4,13 @@

 =head1 NAME

-pdump - Dump or convert Parrot bytecode (PBC) files
+pbc_dump - Dump or convert Parrot bytecode (PBC) files

 =head1 SYNOPSIS

- pdump [-tdh] [--terse|--disassemble|--header-only] file.pbc
+ pbc_dump [-tdh] [--terse|--disassemble|--header-only] file.pbc

- pdump -o converted.pbc file.pbc
+ pbc_dump -o converted.pbc file.pbc

 =head1 DESCRIPTION

@@ -173,10 +173,10 @@

 static void help(void)
 {
-    printf("pdump - dump or convert parrot bytecode (PBC) files\n");
+    printf("pbc_dump - dump or convert parrot bytecode (PBC) files\n");
     printf("usage:\n");
-    printf("pdump [-tdh] [--terse|--disassemble|--header-only] file.pbc\n");
-    printf("pdump -o converted.pbc file.pbc\n\n");
+    printf("pbc_dump [-tdh] [--terse|--disassemble|--header-only] file.pbc\n");
+    printf("pbc_dump -o converted.pbc file.pbc\n\n");
     printf("\t-d ... disassemble bytecode segments\n");
     printf("\t-h ... dump header only\n");
     printf("\t-t ... terse output\n");
Index: src/pdump.c
===================================================================
--- src/pdump.c	(revision 36416)
+++ src/pdump.c	(working copy)
@@ -1,327 +0,0 @@
-/*
-Copyright (C) 2001-2003, The Perl Foundation.
-$Id$
-
-=head1 NAME
-
-pdump - Dump or convert Parrot bytecode (PBC) files
-
-=head1 SYNOPSIS
-
- pdump [-tdh] [--terse|--disassemble|--header-only] file.pbc
-
- pdump -o converted.pbc file.pbc
-
-=head1 DESCRIPTION
-
-A program to dump pack files to human readable form.
-
-=head2 Command-Line Options
-
-=over 4
-
-=item C<-d>
-
-Disassemble bytecode segments.
-
-=item C<-h>
-
-Dump the bytecode header only.
-
-=item C<-t>
-
-Terse output.
-
-=item C<-o converted.pbc>
-
-Repacks a PBC file into the platform's native binary format for better
-efficiency on reading non-native PBCs.
-
-=back
-
-=head2 Functions
-
-=over 4
-
-=cut
-
-*/
-
-#include "parrot/parrot.h"
-#include "parrot/embed.h"
-#include "parrot/oplib/ops.h"
-
-/*
-
-=item C<static void
-const_dump(PARROT_INTERP, const PackFile_Segment *segp)>
-
-Dump the constant table.
-
-=cut
-
-*/
-
-static void
-const_dump(PARROT_INTERP, const PackFile_Segment *segp)
-{
-    Parrot_io_printf(interp, "%s => [\n", segp->name);
-    PackFile_ConstTable_dump(interp, (const PackFile_ConstTable *)segp);
-    Parrot_io_printf(interp, "],\n");
-}
-
-/*
-
-=item C<static void
-fixup_dump(PARROT_INTERP, const PackFile_Segment *segp)>
-
-Dump the fixup table.
-
-=cut
-
-*/
-
-static void
-fixup_dump(PARROT_INTERP, const PackFile_Segment *segp)
-{
-    Parrot_io_printf(interp, "%s => [\n", segp->name);
-    PackFile_Fixup_dump(interp, (const PackFile_FixupTable *)segp);
-    Parrot_io_printf(interp, "],\n");
-}
-
-/*
-
-=item C<static void
-disas_dump(PARROT_INTERP, const PackFile_Segment *self)>
-
-Disassemble and dump.
-
-=cut
-
-*/
-
-static void
-disas_dump(PARROT_INTERP, const PackFile_Segment *self)
-{
-    opcode_t *pc;
-    size_t i, n;
-    Parrot_io_printf(interp, "%s => [ # %d ops at offs 0x%x\n",
-            self->name, (int)self->size, (int)self->file_offset + 4);
-    pc = self->data;
-    while (pc < self->data + self->size) {
-        /* trace_op_dump(interp, self->pf->src, pc); */
-        Parrot_io_printf(interp, " %04x:  ", (int) (pc - self->data));
-        n = (size_t)interp->op_info_table[*pc].op_count;
-        for (i = 0; i < 6; i++)
-            if (i < n)
-                Parrot_io_printf(interp, "%08lx ", (unsigned long) pc[i]);
-            else
-                Parrot_io_printf(interp, "         ");
-        Parrot_io_printf(interp, "%s\n",
-                interp->op_info_table[*pc].full_name);
-        ADD_OP_VAR_PART(interp, interp->code, pc, n);
-        pc += n;
-    }
-    Parrot_io_printf(interp, "]\n");
-}
-
-/*
-
-=item C<static void
-PackFile_header_dump(PARROT_INTERP, PackFile *pf)>
-
-Dump the header.
-
-=cut
-
-*/
-
-static void
-PackFile_header_dump(PARROT_INTERP, PackFile *pf)
-{
-    Parrot_io_printf(interp, "HEADER => [\n");
-    Parrot_io_printf(interp, "\twordsize  = %d", pf->header->wordsize);
-    Parrot_io_printf(interp, "\t(interpreter's wordsize/INTVAL = %d/%d)\n",
-                     sizeof (opcode_t), sizeof (INTVAL));
-    Parrot_io_printf(interp, "\tbyteorder = %d", pf->header->byteorder);
-    Parrot_io_printf(interp, "\t(interpreter's byteorder       = %d)\n",
-            PARROT_BIGENDIAN);
-    Parrot_io_printf(interp, "\tfloattype = %d", pf->header->floattype);
-    Parrot_io_printf(interp, "\t(interpreter's NUMVAL_SIZE     = %d)\n", NUMVAL_SIZE);
-    Parrot_io_printf(interp, "\tparrot-version %d.%d.%d, bytecode-version %d.%d\n",
-                     pf->header->major, pf->header->minor, pf->header->patch,
-                     pf->header->bc_major, pf->header->bc_minor);
-    Parrot_io_printf(interp, "\tUUID type = %d, UUID size = %d\n",
-                     pf->header->uuid_type, pf->header->uuid_size);
-    Parrot_io_printf(interp, "\t%s endianize, %s opcode, %s numval transform\n",
-            pf->need_endianize ? "**need**" : "no",
-            pf->need_wordsize ? "**need**" : "no",
-            pf->fetch_nv ? "**need**" : "no");
-    Parrot_io_printf(interp, "\tdirformat = %d\n", pf->header->dir_format);
-    Parrot_io_printf(interp, "]\n");
-}
-
-/*
-
-=item C<static void help(void)>
-
-Print out the user help info.
-
-=cut
-
-*/
-
-static void help(void)
-{
-    printf("pdump - dump or convert parrot bytecode (PBC) files\n");
-    printf("usage:\n");
-    printf("pdump [-tdh] [--terse|--disassemble|--header-only] file.pbc\n");
-    printf("pdump -o converted.pbc file.pbc\n\n");
-    printf("\t-d ... disassemble bytecode segments\n");
-    printf("\t-h ... dump header only\n");
-    printf("\t-t ... terse output\n");
-    printf("\n\t-o converted.pbc repacks a PBC file into "
-           "the platform's native\n");
-    printf("\t   binary format for better efficiency on reading "
-           "non native PBCs\n");
-    exit(EXIT_SUCCESS);
-}
-
-static struct longopt_opt_decl options[] = {
-    { 'h', 'h', OPTION_optional_FLAG, { "--header-only" } },
-    { '?', '?', OPTION_optional_FLAG, { "--help" } },
-    { 't', 't', OPTION_optional_FLAG, { "--terse" } },
-    { 'd', 'd', OPTION_optional_FLAG, { "--disassemble" } },
-    { 'o', 'o', OPTION_required_FLAG, { "--output" } }
-};
-
-/*
-
-=item C<int
-main(int argc, char **argv)>
-
-The run loop. Process the command-line arguments and dump accordingly.
-
-=cut
-
-*/
-
-int
-main(int argc, const char **argv)
-{
-    PackFile *pf;
-    Interp *interp;
-    int terse = 0;
-    int disas = 0;
-    int convert = 0;
-    int header = 0;
-    const char *file = NULL;
-    struct longopt_opt_info opt = LONGOPT_OPT_INFO_INIT;
-    int status;
-
-    if (argc < 2) {
-        help();
-    }
-    interp = Parrot_new(NULL);
-    /* init and set top of stack */
-    Parrot_init_stacktop(interp, &status);
-    while ((status = longopt_get(interp,
-                    argc, argv, options, &opt)) > 0) {
-        switch (opt.opt_id) {
-            case 'h':
-                header = 1;
-                break;
-            case 't':
-                terse = 1;
-                break;
-            case 'd':
-                disas = 1;
-                break;
-            case 'o':
-                file = opt.opt_arg;
-                convert = 1;
-                break;
-            case '?':
-            default:
-                help();
-                break;
-        }
-    }
-    if (status == -1) {
-        help();
-    }
-    argc -= opt.opt_index;
-    argv += opt.opt_index;
-
-
-    pf = Parrot_readbc(interp, *argv);
-
-    if (!pf) {
-        printf("Can't read PBC\n");
-        return 1;
-    }
-    Parrot_loadbc(interp, pf);
-    if (convert) {
-        size_t size;
-        opcode_t *pack;
-        FILE *fp;
-
-        size = PackFile_pack_size(interp,
-                interp->code->base.pf) * sizeof (opcode_t);
-        pack = (opcode_t*) mem_sys_allocate(size);
-        if (!pack) {
-            printf("out of mem\n");
-            exit(EXIT_FAILURE);
-        }
-        PackFile_pack(interp, interp->code->base.pf, pack);
-        if (STREQ(file, "-"))
-            fp = stdout;
-        else if ((fp = fopen(file, "wb")) == 0) {
-            printf("Couldn't open %s\n", file);
-            exit(EXIT_FAILURE);
-        }
-
-        if ((1 != fwrite(pack, size, 1, fp))) {
-            printf("Couldn't write %s\n", file);
-            exit(EXIT_FAILURE);
-        }
-        fclose(fp);
-        mem_sys_free(pack);
-        Parrot_exit(interp, 0);
-    }
-
-    PackFile_header_dump(interp, pf);
-    if (header) {
-        Parrot_exit(interp, 0);
-    }
-    /* install a dumper function */
-    if (!terse) {
-        pf->PackFuncs[PF_CONST_SEG].dump = const_dump;
-        pf->PackFuncs[PF_FIXUP_SEG].dump = fixup_dump;
-    }
-    if (disas)
-        pf->PackFuncs[PF_BYTEC_SEG].dump = disas_dump;
-    /* do a directory dump, which dumps segs then */
-    PackFile_Segment_dump(interp, &pf->directory.base);
-
-    Parrot_exit(interp, 0);
-}
-
-/*
-
-=back
-
-=head1 SEE ALSO
-
-F<src/packdump.c>.
-
-=cut
-
-*/
-
-/*
- * Local variables:
- *   c-file-style: "parrot"
- * End:
- * vim: expandtab shiftwidth=4:
- */
Index: t/native_pbc/integer.t
===================================================================
--- t/native_pbc/integer.t	(revision 36416)
+++ t/native_pbc/integer.t	(working copy)
@@ -38,13 +38,13 @@

 The output of

-  $ pdump -h i.pbc
+  $ pbc_dump -h i.pbc

 should be included for reference.

 On test failures please add the output of

-  $ ./pdump -h t/native_pbc/number_${N}.pbc
+  $ ./pbc_dump -h t/native_pbc/number_${N}.pbc

 into your report. We need your wordsize/floattype/endianess.

Index: t/native_pbc/number.t
===================================================================
--- t/native_pbc/number.t	(revision 36416)
+++ t/native_pbc/number.t	(working copy)
@@ -32,20 +32,20 @@
 # please add it:

   $ ./parrot -o n.pbc t/op/number_1.pasm
-  $ make pdump
-  $ ./pdump -h n.pbc
+  $ make pbc_dump
+  $ ./pbc_dump -h n.pbc
   $ mv n.pbc t/native_pbc/number_$(N).pbc

 # then
 # - increase number of tests
-# - include the pdump header info for reference
+# - include the pbc_dump header info for reference
 # - put the file into MANIFEST
 # - add the file as binary (svn add) and commit it
 # thanks -leo

 On test failures please add the output of

-  $ ./pdump -h t/native_pbc/number_${N}.pbc
+  $ ./pbc_dump -h t/native_pbc/number_${N}.pbc

 into your report. We need your wordsize/floattype/endianess.

Index: tools/dev/mk_native_pbc
===================================================================
--- tools/dev/mk_native_pbc	(revision 36416)
+++ tools/dev/mk_native_pbc	(working copy)
@@ -25,8 +25,8 @@
 ./parrot -o n.pbc t/op/number_1.pasm
 mv n.pbc t/native_pbc/number_1.pbc

-make pdump
-./pdump -h t/native_pbc/number_1.pbc
-./pdump -h t/native_pbc/number_2.pbc
+make pbc_dump
+./pbc_dump -h t/native_pbc/number_1.pbc
+./pbc_dump -h t/native_pbc/number_2.pbc

 perl t/harness t/native_pbc/number.t
Index: tools/dev/pbc_header.pl
===================================================================
--- tools/dev/pbc_header.pl	(revision 36416)
+++ tools/dev/pbc_header.pl	(working copy)
@@ -30,7 +30,7 @@

 =head1 SEE ALSO

-The C<pdump> utility does a much more thorough job of showing bytecode file
+The C<pbc_dump> utility does a much more thorough job of showing bytecode file
 headers.

 =cut
Index: tools/install/smoke.pl
===================================================================
--- tools/install/smoke.pl	(revision 36416)
+++ tools/install/smoke.pl	(working copy)
@@ -80,9 +80,9 @@
 $out = `$exe`;
 ok($out =~ /^pbc_merge/, "check pbc_merge");

-$exe = catfile($bindir, 'pdump');
+$exe = catfile($bindir, 'pbc_dump');
 $out = `$exe`;
-ok($out =~ /^pdump/, "check pdump");
+ok($out =~ /^pbc_dump/, "check pbc_dump");

 ok(system("$parrot -V") == 0, "display parrot version");

/li>
<li class="comment_forbidden"><span><a href="/user/login?destination=comment%2Freply%2F515%2